> ## Documentation Index
> Fetch the complete documentation index at: https://docs.gobl.org/llms.txt
> Use this file to discover all available pages before exploring further.

# Build a GOBL document

> Parses, calculates, and validates a GOBL document. Optionally wraps the result in an envelope.



## OpenAPI

````yaml /openapi/v0.json post /build
openapi: 3.1.0
info:
  title: GOBL API
  description: >-
    Go Business Language — build, validate, sign, and query tax-aware business
    documents.
  version: v0
  license:
    name: Apache 2.0
    url: https://www.apache.org/licenses/LICENSE-2.0
  contact:
    name: Invopop
    url: https://gobl.org
servers:
  - url: https://gobl.dev/v0
    description: Production
  - url: /v0
    description: Local
security: []
tags:
  - name: Documents
    description: Build, validate, correct, and replicate GOBL documents.
  - name: Signing
    description: Sign and verify GOBL envelopes.
  - name: Reference
    description: JSON schemas, tax regimes, and format addons.
  - name: Meta
    description: Service metadata.
paths:
  /build:
    post:
      tags:
        - Documents
      summary: Build a GOBL document
      description: >-
        Parses, calculates, and validates a GOBL document. Optionally wraps the
        result in an envelope.
      operationId: build
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/BuildRequest'
      responses:
        '200':
          description: Built document or envelope
          content:
            application/json:
              schema: {}
        '400':
          $ref: '#/components/responses/Error'
        '422':
          $ref: '#/components/responses/Error'
components:
  schemas:
    BuildRequest:
      type: object
      required:
        - data
      properties:
        data:
          description: GOBL document to build.
        template:
          description: Optional template to merge with the data before building.
        type:
          type: string
          description: Document type hint (e.g. `bill/invoice`).
        envelop:
          type: boolean
          description: Wrap the result in an envelope.
          default: false
    Error:
      type: object
      properties:
        code:
          type: integer
          description: HTTP status code.
          example: 422
        key:
          type: string
          description: Machine-readable error key.
        message:
          type: string
          description: Human-readable message.
        faults:
          type: array
          description: Validation faults.
          items:
            type: object
            properties:
              properties:
                type: array
                items:
                  type: string
                description: Property paths that failed.
              description:
                type: string
  responses:
    Error:
      description: Error response
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/Error'

````